-- Represent the special curses ACS_ characters as their Unicode codepoints,
-- so that the rest of the program can handle them more easily.
-- The codepoints were mostly taken from a discussion archived at:
-- http://lists.w3.org/Archives/Public/www-html/1996Jul/0192.html

module BoxChar where

ch_ulcorner, ch_llcorner, ch_urcorner, ch_lrcorner :: Char
ch_ulcorner = '\x2518'
ch_llcorner = '\x2510'
ch_urcorner = '\x2514'
ch_lrcorner = '\x250C'

ch_ltee, ch_rtee, ch_btee, ch_ttee :: Char
ch_ltee = '\x251C'
ch_rtee = '\x2524'
ch_btee = '\x2534'
ch_ttee = '\x252C'

ch_hline, ch_vline, ch_plus :: Char
ch_hline = '\x2500'
ch_vline = '\x2502'
ch_plus = '\x253C'

ch_diamond :: Char
ch_diamond = '\x25CA'

ch_bullet :: Char
ch_bullet = '\x2022'

ch_larrow, ch_rarrow, ch_darrow, ch_uarrow :: Char
ch_larrow = '\x2190'
ch_rarrow = '\x2192'
ch_darrow = '\x2193'
ch_uarrow = '\x2191'

ch_board :: Char
ch_board = '\x25A6'

ch_block :: Char
ch_block = '\x25A0'
