-- Possible input keys that the Curses module can read.
-- This module is separated from the Curses module so that the action
-- functions can deal with Keys without having to import Curses.
module Keys (
  Key(..)
) where

data Key = Key Char
         | Key_UP | Key_DOWN | Key_LEFT | Key_RIGHT  -- Arrow keys
         | Key_BACKSPACE | Key_DEL   -- DEL is DC in curses
         | Key_HOME | Key_END | Key_NPAGE | Key_PPAGE
         | Key_ENTER
         -- These correspond to A1, A3, B2, C1, and C3 in curses.
         -- Same meaning, more descriptive names.
         | Key_UPLEFT | Key_UPRIGHT | Key_CENTER | Key_DOWNLEFT | Key_DOWNRIGHT
         | NoKey
 deriving (Eq, Ord)
